## INTRODUCTION

The Webform Advancedqueue module provides a Webform handler that sends webform submissions to an Advanced Queue job. This allows you to process submissions asynchronously using the Advanced Queue system, which is ideal for offloading time-consuming or external processing tasks from the main web request.

The primary use case for this module is:

- Offloading webform submission processing to background jobs (e.g., sending data to external APIs, processing files, or triggering batch operations).
- Integrating webform submissions with custom Advanced Queue job types for scalable, decoupled workflows.
- Improving site performance and user experience by handling heavy-lifting tasks outside the main request/response cycle.

## REQUIREMENTS

- Drupal 10 or 11
- [Webform module](https://www.drupal.org/project/webform)
- [Advanced Queue module](https://www.drupal.org/project/advancedqueue)

## INSTALLATION

Install as you would normally install a contributed Drupal module:

1. Download the module using Composer:
   - `composer require drupal/webform_advancedqueue`
2. Enable the module via the Drupal admin UI or with Drush:
   - `drush en webform_advancedqueue`
3. Ensure the Advanced Queue and Webform modules are also enabled (Composer will handle dependencies if available on drupal.org).

See: https://www.drupal.org/node/895232 for further information.

## CONFIGURATION

1. Go to the Webform edit page for the form you want to process via Advanced Queue.
2. Add a new handler of type "Webform Advanced Queue".
3. Select the target Advanced Queue and job type from the handler settings.
4. Optionally enable debugging to display handler method invocations onscreen.
5. Save the handler and the webform.

When a submission is completed, its data will be sent to the selected Advanced Queue as a job of the chosen type.

## THEME

This module provides a summary template for the advanced queue webform handler:

- Template: templates/webform-handler-webform-advancedqueue-summary.html.twig
- Theme hook: webform_handler_webform_advancedqueue_summary

## MAINTAINERS

Current maintainers for Drupal 10/11:

- Tomasz Trzcinski (tomasztrzcinski) - https://www.drupal.org/u/tomasztrzcinski
